#!/usr/bin/perl
#Majid Masso
#School of Systems Biology, George Mason University
#April 2013
#For use with the AutoMute2 portable version
$arg=0;
for($i=0;$i<@ARGV;$i++){
	if($ARGV[$i] eq "-p"){
		$potfile=$ARGV[$i+1];
		$arg++;
	}
	elsif($ARGV[$i] eq "-e"){
		$pdbfile=$ARGV[$i+1];
		$arg++;
	}
	elsif($ARGV[$i] eq "-m"){
		$mute=$ARGV[$i+1];
		$arg++;
	}
	elsif($ARGV[$i] eq "-c"){
		$cutoff=$ARGV[$i+1];
		$arg++;
	}
}
if($arg!=4){die "Usage: perl mutant_potential_automute.pl -p <potential_file> -e <PDB_file> -m <single_point_mutation> -c <tessellation_edge_cutoff>\n";}
$c=0;
open(POT, "perl .//AutoMute2_support_programs//potential_profile_automute_alt.pl -p $potfile -e $pdbfile -c $cutoff |");
while(<POT>){
	chomp($_);
	($num1[$c],$aa1[$c],$pot1[$c])=split(/\s+/,$_);$c++;
}
close(POT);
$d=0;
open(RESULT, "perl .//AutoMute2_support_programs//potential_profile_automute_alt.pl -p $potfile -e $pdbfile -m $mute -c $cutoff |");
while(<RESULT>){
	chomp($_);
	($num2[$d],$aa2[$d],$pot2[$d])=split(/\s+/,$_);$d++;
}
close(RESULT); 
print "$mute\nResidue   WTseq_aa   WT_potential   MUTseq_aa   MUT_potential   Diff(MUT-WT)_potential\n";
for($j=0;$j<$c-1;$j++){
	$diff=$pot2[$j]-$pot1[$j];
	printf ("%5d       %3s     %13.9f      %3s      %13.9f       %13.9f\n",$num1[$j],$aa1[$j],$pot1[$j],$aa2[$j],$pot2[$j],$diff);
}
$diffscore=$pot2[$c-1]-$pot1[$c-1];
printf ("Total:              %13.9f               %13.9f       %13.9f\n",$pot1[$c-1],$pot2[$c-1],$diffscore);
