#!/usr/bin/perl
#Majid Masso
#School of Systems Biology, George Mason University
#April 2013
#For use only with the AutoMute2 portable version
%reslist=('A'=>'ALA','C'=>'CYS','D'=>'ASP','E'=>'GLU','F'=>'PHE','G'=>'GLY','H'=>'HIS','I'=>'ILE','K'=>'LYS','L'=>'LEU','M'=>'MET','N'=>'ASN','P'=>'PRO','Q'=>'GLN','R'=>'ARG','S'=>'SER','T'=>'THR','V'=>'VAL','W'=>'TRP','Y'=>'TYR');
@quad=();@score=();$arg=0;
for($i=0;$i<@ARGV;$i++){
	if($ARGV[$i] eq "-p"){
		$potfile=$ARGV[$i+1];
		$arg++;
	}
	elsif($ARGV[$i] eq "-e"){
		$pdbfile=$ARGV[$i+1];
		$arg++;
	}
	elsif($ARGV[$i] eq "-c"){
		$cutoff=$ARGV[$i+1];
		$arg++;
	}
}
if($arg!=3){die "Usage: perl potential_profile_automute.pl -p <potential_file> -e <PDB_file> -c <tessellation_edge_cutoff>\n";}
open(POT, "$potfile");
while(<POT>){
	chomp($_);
	@pot=split(/\s+/,$_);
	push(@quad,$pot[0]); push(@score,$pot[1]);
}
close(POT);
$chain=uc(substr($pdbfile,4,1));
open(PDB, "perl .//AutoMute2_support_programs//residue_filter_automute.pl -e $pdbfile |");
$ct=0;@aas=();@coords=();$reslog=-100000;%residues=();
$he=0;$sh=0;@starth=();@endh=();@starts=();@ends=();
while(<PDB>){
	unless($_=~/^HELIX/ || $_=~/^SHEET/){
		chomp($_);
		$at=substr($_,13,3);$res=substr($_,17,3);$resnum=substr($_,22,4);
		$x=substr($_,30,8);$y=substr($_,38,8);$z=substr($_,46,8);
		$ct++;@point=($x,$y,$z);push(@coords,[ @point ]);
		if($resnum!=$reslog){
			$reslog=$resnum;
			$residues{$resnum}=$res;
		}
		if($res eq $reslist{"A"}){push(@aas,('A'));}
		elsif($res eq $reslist{"C"}){push(@aas,('C'));}
		elsif($res eq $reslist{"D"}){push(@aas,('D'));}
		elsif($res eq $reslist{"E"}){push(@aas,('E'));}
		elsif($res eq $reslist{"F"}){push(@aas,('F'));}
		elsif($res eq $reslist{"G"}){push(@aas,('G'));}
		elsif($res eq $reslist{"H"}){push(@aas,('H'));}
		elsif($res eq $reslist{"I"}){push(@aas,('I'));}
		elsif($res eq $reslist{"K"}){push(@aas,('K'));}
		elsif($res eq $reslist{"L"}){push(@aas,('L'));}
		elsif($res eq $reslist{"M"}){push(@aas,('M'));}
		elsif($res eq $reslist{"N"}){push(@aas,('N'));}
		elsif($res eq $reslist{"P"}){push(@aas,('P'));}
		elsif($res eq $reslist{"Q"}){push(@aas,('Q'));}
		elsif($res eq $reslist{"R"}){push(@aas,('R'));}
		elsif($res eq $reslist{"S"}){push(@aas,('S'));}
		elsif($res eq $reslist{"T"}){push(@aas,('T'));}
		elsif($res eq $reslist{"V"}){push(@aas,('V'));}
		elsif($res eq $reslist{"W"}){push(@aas,('W'));}
		elsif($res eq $reslist{"Y"}){push(@aas,('Y'));}
	}
	if($_=~/^HELIX/ && (substr($_,19,1) eq ' ' || substr($_,19,1) eq $chain) && (substr($_,31,1) eq ' ' || substr($_,31,1) eq $chain)){$starth[$he]=substr($_,21,4);$endh[$he]=substr($_,33,4);$he++;}
	elsif($_=~/^SHEET/ && (substr($_,21,1) eq ' ' || substr($_,21,1) eq $chain) && (substr($_,32,1) eq ' ' || substr($_,32,1) eq $chain)){$starts[$sh]=substr($_,22,4);$ends[$sh]=substr($_,33,4);$sh++;}
}
close(PDB);
if($reslog==-100000){die "Support program terminating...\n";}
@resnumkeys=sort{$a<=>$b}(keys(%residues));
for($i=0;$i<$he;$i++){
	for($j=$starth[$i];$j<=$endh[$i];$j++){
		$ss[$j-$resnumkeys[0]]='H';
	}
}
for($i=0;$i<$sh;$i++){
	for($j=$starts[$i];$j<=$ends[$i];$j++){
		$ss[$j-$resnumkeys[0]]='S';
	}
}
for($i=0;$i<$ct;$i++){
	if($ss[$i] ne 'H' && $ss[$i] ne 'S'){
		$ss[$i]='C';
	}
}
open(INPUT, ">dinputs.txt");
print INPUT "3\n$ct\n";
for($i=0;$i<$ct;$i++){
	print INPUT "@{@coords[$i]}\n";
}
close(INPUT);
system("qhull d Qbb < dinputs.txt i > doutputs.txt");
open(FILE, "doutputs.txt");
@aascores=();$totalscore=0;@allinds=();@quadindscores=();$indsct=0;
while(<FILE>){
	chomp($_);
	@inds=split(/ /,$_); $indsize=@inds;
	if($indsize==4){@inds=sort{$a<=>$b}(@inds);push(@everyinds,[@inds]);
	$LA=sqrt(($coords[$inds[0]][0]-$coords[$inds[1]][0])**2+($coords[$inds[0]][1]-$coords[$inds[1]][1])**2+($coords[$inds[0]][2]-$coords[$inds[1]][2])**2); push(@L1,$LA);
	$LB=sqrt(($coords[$inds[0]][0]-$coords[$inds[2]][0])**2+($coords[$inds[0]][1]-$coords[$inds[2]][1])**2+($coords[$inds[0]][2]-$coords[$inds[2]][2])**2); push(@L2,$LB);
	$LC=sqrt(($coords[$inds[0]][0]-$coords[$inds[3]][0])**2+($coords[$inds[0]][1]-$coords[$inds[3]][1])**2+($coords[$inds[0]][2]-$coords[$inds[3]][2])**2); push(@L3,$LC);
	$LD=sqrt(($coords[$inds[1]][0]-$coords[$inds[2]][0])**2+($coords[$inds[1]][1]-$coords[$inds[2]][1])**2+($coords[$inds[1]][2]-$coords[$inds[2]][2])**2); push(@L4,$LD);
	$LE=sqrt(($coords[$inds[1]][0]-$coords[$inds[3]][0])**2+($coords[$inds[1]][1]-$coords[$inds[3]][1])**2+($coords[$inds[1]][2]-$coords[$inds[3]][2])**2); push(@L5,$LE);
	$LF=sqrt(($coords[$inds[2]][0]-$coords[$inds[3]][0])**2+($coords[$inds[2]][1]-$coords[$inds[3]][1])**2+($coords[$inds[2]][2]-$coords[$inds[3]][2])**2); push(@L6,$LF);
	$Lavg=($LA+$LB+$LC+$LD+$LE+$LF)/6;	 push(@L7,$Lavg);
	if($LA<=$cutoff && $LB<=$cutoff && $LC<=$cutoff && $LD<=$cutoff && $LE<=$cutoff && $LF<=$cutoff){
		push(@allinds,[@inds]);
		$Tet[$indsct]=(($LB-$LA)**2+($LC-$LA)**2+($LD-$LA)**2+($LE-$LA)**2+($LF-$LA)**2+($LC-$LB)**2+($LD-$LB)**2+($LE-$LB)**2+($LF-$LB)**2+($LD-$LC)**2+($LE-$LC)**2+($LF-$LC)**2+($LE-$LD)**2+($LF-$LD)**2+($LF-$LE)**2)/(15*($Lavg)**2);
		$Vol[$indsct]=abs(($coords[$inds[0]][0]-$coords[$inds[1]][0])*($coords[$inds[0]][1]-$coords[$inds[2]][1])*($coords[$inds[0]][2]-$coords[$inds[3]][2])+($coords[$inds[0]][0]-$coords[$inds[3]][0])*($coords[$inds[0]][1]-$coords[$inds[1]][1])*($coords[$inds[0]][2]-$coords[$inds[2]][2])+($coords[$inds[0]][0]-$coords[$inds[2]][0])*($coords[$inds[0]][1]-$coords[$inds[3]][1])*($coords[$inds[0]][2]-$coords[$inds[1]][2])-($coords[$inds[0]][0]-$coords[$inds[3]][0])*($coords[$inds[0]][1]-$coords[$inds[2]][1])*($coords[$inds[0]][2]-$coords[$inds[1]][2])-($coords[$inds[0]][0]-$coords[$inds[1]][0])*($coords[$inds[0]][1]-$coords[$inds[3]][1])*($coords[$inds[0]][2]-$coords[$inds[2]][2])-($coords[$inds[0]][0]-$coords[$inds[2]][0])*($coords[$inds[0]][1]-$coords[$inds[1]][1])*($coords[$inds[0]][2]-$coords[$inds[3]][2]))/6;
		$indsct++;
		@letters=($aas[$inds[0]],$aas[$inds[1]],$aas[$inds[2]],$aas[$inds[3]]);
		@sorted=sort(@letters);
		$ngram=$sorted[0].$sorted[1].$sorted[2].$sorted[3];
		for($i=0;$i<@quad;$i++){
			if($ngram eq $quad[$i]){
				push(@quadindscores,$score[$i]);
				$totalscore+=$score[$i];
				for($j=0;$j<4;$j++){
					$aascores[$inds[$j]]+=$score[$i];
				}
				last;
			}
		}
	}
	}
}
close(FILE);
@tri=();$q=@everyinds;
for($j=0;$j<$q;$j++){
	push(@tri,[$everyinds[$j][0],$everyinds[$j][1],$everyinds[$j][2]]);
	push(@tri,[$everyinds[$j][0],$everyinds[$j][1],$everyinds[$j][3]]);
	push(@tri,[$everyinds[$j][0],$everyinds[$j][2],$everyinds[$j][3]]);
	push(@tri,[$everyinds[$j][1],$everyinds[$j][2],$everyinds[$j][3]]);
}
$re=@tri;@sur=();@surout=();@under=();@underout=();
for($i=0;$i<$re;$i++){
	$aa=0;
	for($j=0;$j<$re;$j++){
		if($tri[$j][0]==$tri[$i][0] && $tri[$j][1]==$tri[$i][1] && $tri[$j][2]==$tri[$i][2]){$aa++;}
	}
	if($aa==1){push(@sur,($tri[$i][0],$tri[$i][1],$tri[$i][2]));
		for($j=0;$j<$q;$j++){
			if($tri[$i][0]==$everyinds[$j][0] && $tri[$i][1]==$everyinds[$j][1] && $tri[$i][2]==$everyinds[$j][2]){push(@under,$everyinds[$j][3]);}
			elsif($tri[$i][0]==$everyinds[$j][0] && $tri[$i][1]==$everyinds[$j][1] && $tri[$i][2]==$everyinds[$j][3]){push(@under,$everyinds[$j][2]);}
			elsif($tri[$i][0]==$everyinds[$j][0] && $tri[$i][1]==$everyinds[$j][2] && $tri[$i][2]==$everyinds[$j][3]){push(@under,$everyinds[$j][1]);}
			elsif($tri[$i][0]==$everyinds[$j][1] && $tri[$i][1]==$everyinds[$j][2] && $tri[$i][2]==$everyinds[$j][3]){push(@under,$everyinds[$j][0]);}
		}
	}
}
$k=@under;$l=@sur;
@underout=sort{$a<=>$b}(@under);
@surout=sort{$a<=>$b}(@sur);
for($i=0;$i<$k;$i++){
	for($j=0;$j<$l;$j++){
		if($underout[$i]==$sur[$j]){splice(@underout,$i,1);$k=@underout;}
	}
}
@underlist=($underout[0]);@underct=();$nn=1;$uw=0;
for($i=0;$i<$k-1;$i++){
	if($underout[$i+1]>$underout[$i]){push(@underlist,$underout[$i+1]);$underct[$uw]=$nn;$nn=1;if($i+1==$k-1){$underct[$uw+1]=1;}$uw++;}
	else{$nn++;if($i+1==$k-1){$underct[$uw]=$nn;}}
}
@surlist=($surout[0]);@surct=();$nn=1;$uw=0;
for($i=0;$i<$l-1;$i++){
	if($surout[$i+1]>$surout[$i]){push(@surlist,$surout[$i+1]);$surct[$uw]=$nn;$nn=1;if($i+1==$l-1){$surct[$uw+1]=1;}$uw++;}
	else{$nn++;if($i+1==$l-1){$surct[$uw]=$nn;}}
}
@depth=();@count=();
for($i=0;$i<$ct;$i++){
	$depth[$i]='B';$count[$i]=0;
	for($j=0;$j<@surlist;$j++){
		if($surlist[$j]==$i){$depth[$i]='S';$count[$i]=$surct[$j];last;}
	}
	for($k=0;$k<@underlist;$k++){
		if($underlist[$k]==$i){$depth[$i]='U';$count[$i]=$underct[$k];last;}
	}
}
$f=0;
for($i=0;$i<$ct;$i++){
	for($j=0;$j<$indsct;$j++){
		if($i==$allinds[$j][0] || $i==$allinds[$j][1] || $i==$allinds[$j][2] || $i==$allinds[$j][3]){
			$SumTet[$i]+=$Tet[$j];$SumVol[$i]+=$Vol[$j];$f++;
		}
	}
	if($f!=0){
		$MeanTet[$i]=$SumTet[$i]/$f;$MeanVol[$i]=$SumVol[$i]/$f;$f=0;
	}
	else{
		$MeanTet[$i]=0;$MeanVol[$i]=0;
	}
}
print "aa   Residue  Chain     Potential   Volume    sT   Depth  Count  SecStr\n";
for($i=0;$i<$ct;$i++){
	$j=$i+$resnumkeys[0];
	printf ("%3s %5d       %1s   %13.9f    %4.1f    %4.2f    %1s    %3d       %1s\n",$residues{$resnumkeys[$i]},$j,$chain,$aascores[$i],$MeanVol[$i],$MeanTet[$i],$depth[$i],$count[$i],$ss[$i]);
}
printf ("Total Potential:    %13.9f\n",$totalscore);
