#!/usr/bin/perl
#Majid Masso
#School of Systems Biology, George Mason University
#April 2013
#For use only with the AutoMute2 server
%reslist=('A'=>'ALA','C'=>'CYS','D'=>'ASP','E'=>'GLU','F'=>'PHE','G'=>'GLY','H'=>'HIS','I'=>'ILE','K'=>'LYS','L'=>'LEU','M'=>'MET','N'=>'ASN','P'=>'PRO','Q'=>'GLN','R'=>'ARG','S'=>'SER','T'=>'THR','V'=>'VAL','W'=>'TRP','Y'=>'TYR');
@quad=();@score=();$arg=0;
for($i=0;$i<@ARGV;$i++){
	if($ARGV[$i] eq "-p"){
		$potfile=$ARGV[$i+1];
		$arg++;
	}
	elsif($ARGV[$i] eq "-e"){
		$pdbfile=$ARGV[$i+1];
		$arg++;
	}
	elsif($ARGV[$i] eq "-c"){
		$cutoff=$ARGV[$i+1];
		$arg++;
	}
}
if($arg!=3){die "Usage: perl simplex_automute.pl -p <potential_file> -e <PDB_file> -c <tessellation_edge_cutoff>\n";}
open(POT, "$potfile");
while(<POT>){
	chomp($_);
	@pot=split(/\s+/,$_);
	push(@quad,$pot[0]); push(@score,$pot[1]);
}
close(POT);
$chain=substr($pdbfile,4,1);
open(PDB, "perl .//AutoMute2_support_programs//residue_filter_automute.pl -e $pdbfile |");
$ct=0;@aas=();@coords=();$reslog=-100000;%residues=();
while(<PDB>){
	unless($_=~/^HELIX/ || $_=~/^SHEET/){
		chomp($_);
		$at=substr($_,13,3);$res=substr($_,17,3);$resnum=substr($_,22,4);
		$x=substr($_,30,8);$y=substr($_,38,8);$z=substr($_,46,8);
		$ct++;@point=($x,$y,$z);push(@coords,[ @point ]);
		if($resnum!=$reslog){
			$reslog=$resnum;
			$residues{$resnum}=$res;
		}
		if($res eq $reslist{"A"}){push(@aas,('A'));}
		elsif($res eq $reslist{"C"}){push(@aas,('C'));}
		elsif($res eq $reslist{"D"}){push(@aas,('D'));}
		elsif($res eq $reslist{"E"}){push(@aas,('E'));}
		elsif($res eq $reslist{"F"}){push(@aas,('F'));}
		elsif($res eq $reslist{"G"}){push(@aas,('G'));}
		elsif($res eq $reslist{"H"}){push(@aas,('H'));}
		elsif($res eq $reslist{"I"}){push(@aas,('I'));}
		elsif($res eq $reslist{"K"}){push(@aas,('K'));}
		elsif($res eq $reslist{"L"}){push(@aas,('L'));}
		elsif($res eq $reslist{"M"}){push(@aas,('M'));}
		elsif($res eq $reslist{"N"}){push(@aas,('N'));}
		elsif($res eq $reslist{"P"}){push(@aas,('P'));}
		elsif($res eq $reslist{"Q"}){push(@aas,('Q'));}
		elsif($res eq $reslist{"R"}){push(@aas,('R'));}
		elsif($res eq $reslist{"S"}){push(@aas,('S'));}
		elsif($res eq $reslist{"T"}){push(@aas,('T'));}
		elsif($res eq $reslist{"V"}){push(@aas,('V'));}
		elsif($res eq $reslist{"W"}){push(@aas,('W'));}
		elsif($res eq $reslist{"Y"}){push(@aas,('Y'));}
	}
}
close(PDB);
if($reslog==-100000){die "Support program terminating...\n";}
@resnumkeys=sort{$a<=>$b}(keys(%residues));
open(INPUT, ">dinputs.txt");
print INPUT "3\n$ct\n";
for($i=0;$i<$ct;$i++){
	print INPUT "@{@coords[$i]}\n";
}
close(INPUT);
system("qhull d Qbb < dinputs.txt i > doutputs.txt");
open(FILE, "doutputs.txt");
@aascores=();$totalscore=0;@allinds=();@quadindscores=();$indsct=0;
while(<FILE>){
	chomp($_);
	@inds=split(/ /,$_); $indsize=@inds;
	if($indsize==4){@inds=sort{$a<=>$b}(@inds);push(@everyinds,[@inds]);
	$LA=sqrt(($coords[$inds[0]][0]-$coords[$inds[1]][0])**2+($coords[$inds[0]][1]-$coords[$inds[1]][1])**2+($coords[$inds[0]][2]-$coords[$inds[1]][2])**2); push(@L1,$LA);
	$LB=sqrt(($coords[$inds[0]][0]-$coords[$inds[2]][0])**2+($coords[$inds[0]][1]-$coords[$inds[2]][1])**2+($coords[$inds[0]][2]-$coords[$inds[2]][2])**2); push(@L2,$LB);
	$LC=sqrt(($coords[$inds[0]][0]-$coords[$inds[3]][0])**2+($coords[$inds[0]][1]-$coords[$inds[3]][1])**2+($coords[$inds[0]][2]-$coords[$inds[3]][2])**2); push(@L3,$LC);
	$LD=sqrt(($coords[$inds[1]][0]-$coords[$inds[2]][0])**2+($coords[$inds[1]][1]-$coords[$inds[2]][1])**2+($coords[$inds[1]][2]-$coords[$inds[2]][2])**2); push(@L4,$LD);
	$LE=sqrt(($coords[$inds[1]][0]-$coords[$inds[3]][0])**2+($coords[$inds[1]][1]-$coords[$inds[3]][1])**2+($coords[$inds[1]][2]-$coords[$inds[3]][2])**2); push(@L5,$LE);
	$LF=sqrt(($coords[$inds[2]][0]-$coords[$inds[3]][0])**2+($coords[$inds[2]][1]-$coords[$inds[3]][1])**2+($coords[$inds[2]][2]-$coords[$inds[3]][2])**2); push(@L6,$LF);
	$Lavg=($LA+$LB+$LC+$LD+$LE+$LF)/6;	 push(@L7,$Lavg);
	if($LA<=$cutoff && $LB<=$cutoff && $LC<=$cutoff && $LD<=$cutoff && $LE<=$cutoff && $LF<=$cutoff){
		push(@allinds,[@inds]);
		$indsct++;
		@letters=($aas[$inds[0]],$aas[$inds[1]],$aas[$inds[2]],$aas[$inds[3]]);
		@sorted=sort(@letters);
		$ngram=$sorted[0].$sorted[1].$sorted[2].$sorted[3];
		for($i=0;$i<@quad;$i++){
			if($ngram eq $quad[$i]){
				push(@quadindscores,$score[$i]);
				$totalscore+=$score[$i];
				for($j=0;$j<4;$j++){
					$aascores[$inds[$j]]+=$score[$i];
				}
				last;
			}
		}
	}
	}
}
close(FILE);
$q=@everyinds;
print "$ct residues   $q quadruplets\n";
print "Quad Type   V1    V2    V3    V4     L1        L2        L3        L4        L5        L6        AvgL\n";
for($i=0;$i<$q;$i++){
	if($everyinds[$i][0]+3==$everyinds[$i][3]){$type[$i]=4;}
	elsif(($everyinds[$i][0]+2==$everyinds[$i][2] && $everyinds[$i][2]+1<$everyinds[$i][3]) || ($everyinds[$i][0]+1<$everyinds[$i][1] && $everyinds[$i][1]+2==$everyinds[$i][3])){$type[$i]=3;}
	elsif($everyinds[$i][0]+1==$everyinds[$i][1] && $everyinds[$i][2]+1==$everyinds[$i][3] && $everyinds[$i][1]+1<$everyinds[$i][2]){$type[$i]=2;}
	elsif(($everyinds[$i][0]+1==$everyinds[$i][1] && $everyinds[$i][1]+1<$everyinds[$i][2] && $everyinds[$i][2]+1<$everyinds[$i][3]) || ($everyinds[$i][1]+1==$everyinds[$i][2] && $everyinds[$i][0]+1<$everyinds[$i][1] && $everyinds[$i][2]+1<$everyinds[$i][3]) || ($everyinds[$i][2]+1==$everyinds[$i][3] && $everyinds[$i][0]+1<$everyinds[$i][1] && $everyinds[$i][1]+1<$everyinds[$i][2])){$type[$i]=1;}
	elsif($everyinds[$i][0]+1<$everyinds[$i][1] && $everyinds[$i][1]+1<$everyinds[$i][2] && $everyinds[$i][2]+1<$everyinds[$i][3]){$type[$i]=0;}
	for($j=0;$j<4;$j++){
		$shiftinds[$i][$j]=$everyinds[$i][$j]+$resnumkeys[0];
	}
	printf ("%4s  %1d  %5d %5d %5d %5d  %7.3f   %7.3f   %7.3f   %7.3f   %7.3f   %7.3f   %7.3f\n",$aas[$everyinds[$i][0]].$aas[$everyinds[$i][1]].$aas[$everyinds[$i][2]].$aas[$everyinds[$i][3]],$type[$i],$shiftinds[$i][0],$shiftinds[$i][1],$shiftinds[$i][2],$shiftinds[$i][3],$L1[$i],$L2[$i],$L3[$i],$L4[$i],$L5[$i],$L6[$i],$L7[$i]);
}
